---
title: Separation Logic Infer Lab 2016
project_id: infe
menu: false
parent_menu: Teaching
menu_order: 5
sub_menu_order: 2
---

The [Separation Logic](https://psvg.doc.ic.ac.uk/teaching/separationlogic.html) course is a 4th-year MEng and MSc course 
on local reasoning about programs that manipulate the heap at the [Department of Computing](http://www.imperial.ac.uk/computing),
[Imperial College London](http://www.imperial.ac.uk). The course is led by [Philippa Gardner](/people/gardner.html), with support 
from [Jose Fragoso](https://www.doc.ic.ac.uk/~jfaustin/), [Daiva Naudžiūnienė](https://www.doc.ic.ac.uk/~dn911/), 
[Azalea Raad](http://www.soundandcomplete.org/) and [Julian Sutherland](https://psvg.doc.ic.ac.uk/people/sutherland.html).

As part of the course, [Peter O’Hearn](http://www.pl-enthusiast.net/2015/09/15/facebooks-peter-ohearn-on-programming-languages/) 
and [Jules Villard](https://www.doc.ic.ac.uk/~jvillar1/) from Facebook came to Imperial College to talk about [Infer](http://fbinfer.com/), 
an automatic verification tool based on separation logic, developed at [Facebook](https://www.facebook.com/inferstaticanalyzer/). 
At Facebook, Infer is used every day to verify millions of lines of code. Infer was 
[open sourced](https://code.facebook.com/posts/1648953042007882/open-sourcing-facebook-infer-identify-bugs-before-you-ship/) 
in June 2015. As well as Facebook, Infer is used by Instagram, kiuwan, oculus, Spotify, UBER, WhatsApp, Marks and Spencer, and Sky. 

![Infer Lab](/images/images/Infer-lab-1-medium.jpg) ![Infer Lab](/images/images/Infer-lab-3-medium.jpg)

The lab offered students an opportunity to run Infer on real world Android applications, such as:

 - [PocketHub](https://github.com/pockethub/PocketHub)
 - [Wikipedia Android app](https://github.com/wikimedia/apps-android-wikipedia)
 - [DuckDuckGo](https://github.com/duckduckgo/duckduckgo)
 - [k-9 mail client](https://github.com/k9mail/k-9)
 
Peter O’Hearn, Engineering Manager at Facebook and leader of the Infer team, gave an overview of the use of Infer at Facebook. 
Jules Villard, Software Engineer at Facebook, gave a tutorial on bi-abduction, 
based on the [slides](/teaching/Bi-Abduction-slides-Sutherland.pdf) that he developed together with Daiva Naudžiūnienė whilst 
a Post-Doc at Imperial College London. 

Peter, Jules and the Imperial team then showed students at the lab how to use Infer on real worl applications. 
During the tutorial, one of the students, 
Lorenzo Paoliani, ran Infer on [ConnectBot](https://play.google.com/store/apps/details?id=org.connectbot&hl=en_GB), 
an SSH client for Android, and found a resource leak bug. He reported this on  github and submitted 
a pull request for fixing this problem, which has been accepted and now merged.
You can see Lorenzo’s [pull request here.](https://github.com/connectbot/connectbot/pull/448)

![Infer Lab](/images/images/Infer-lab-2-small.jpg)

To follow the Infer team, check their [blog](http://fbinfer.com/blog/) or [Twitter](https://twitter.com/fbinfer). 
For more details on the Infer lab or the Separation Logic course, contact the Imperial team below.
